== Metamaps
Metamaps is a free and open source technology for changemakers, innovators, educators and students. It enables individuals and communities to build and visualize their shared knowledge and unlock their collective intelligence. You can find out about more about the project at http://blog.metamaps.cc.

You can find a version of this software running at http://metamaps.cc, where the technology is being beta tested in a private beta, if you're not up to the task of running your own version. 

Metamaps is created and maintained by a distributed, nomadic community comprised of technologists, artists and storytellers. You can get in touch with us at team@metamaps.cc or @metamapps on twitter. 

To get connected with the community interested in Metamaps, join our G+ community. https://plus.google.com/u/0/communities/115060009262157699234

To contribute to Metamaps, fork this repository, and submit a pull request!

==How to code in Metamaps

First off, Metamaps runs on Ruby On Rails. Ruby 1.9.3 and Rails 3.2. You'll need to get Ruby and Rails installed on your computer if you don't already have it. We recommend using the Rails Installer, which you can download from Mac or Windows at http://railsinstaller.org/en (see the notes below about Ubuntu). This will get you set up perfectly with the right versions of Ruby, and Rails for running your local version of Metamaps.

It uses postgreSQL 9.2 as a database. You can install that for your computer from here: http://www.enterprisedb.com/products-services-training/pgdownload

Once you install those, open a 'command prompt with ruby and rails'. 

Navigate to the folder that you want to download the metamaps files to and run (use your forked git repository address if it's different than this repo.)
  git clone git@github.com:Connoropolous/metamaps_gen002.git
  cd metamaps_gen002
  
Now you're in the main directory. 

Setting up the database:

1) Copy database.yml.default to database.yml
 
2) In a terminal:
  $ rake db:create
  $ rake db:schema:load
  $ rake db:fixtures:load

Running the server:

  $rails s #runs the server
  
Navigate your browser to localhost:3000 once you have the server running

Sign in with the default account

email: user@user.com

password: toolsplusconsciousness

OR create a new account at /users/sign_up, and use access code 'qwertyui'

Start mapping and programming!


==Installing on Ubuntu

I had a lot of trouble installing on Ubuntu
I had to install postgresql and libpq-dev. I had to do $rvm reinstall ruby-1.9.3-p125
execjs complained there was no runtime, so I added gem 'therubyracer' to the Gemfile


== The Important Files

Here are the important folders/files:

config/database.yml: This file is your database configuration. If it doesn't exist, copy it from config/database.yml.default and then get it set up. config/database.yml is in .gitignore

app/assets/javascripts/application.js: Global Javascript

app/assets/javascripts/Jit/*: These files handle all code that uses the Javascript Infovis Toolkit, so realistically, most code for laying stuff out is in here.

app/assets/controllers/*: These files define actions you can do on the different database objects. So for instance, what happens when you edit a Synapse? Check in app/assets/controllers/synapse_controller.rb, in the edit block

app/assets/views/*.html.erb: Files in here define either html that is displayed when a certain action is called (like edit, or create) on a thing. E.G. app/assets/views/topic/new.html.erb would have a form for creating a new topic. We don't use that way very much anymore though. "Partial" views can be called elsewhere in ruby code and are prefixed with an underscore. So we focus more on the files starting with an underscore. Read through the comments at the top of each file to understand what they all do.

app/assets/views/*.js.erb: Javascript that is called in response to, e.g., editing or creating a topic, synapse, etc.


== Contact

With any questions or comments, contact Ishan Shapiro and Connor Turland at team@metamaps.cc.


== Licensing Information
Metamaps.cc, a visual knowledge communication engine.
Copyright (C) 2014 Topos FFO

This program is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or(at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with this program.  If not, see [http://www.gnu.org/licenses/].
